;
;       unwlib.asm
;
code    segment
        org     100h
        assume  cs:code, ds:code
begin:  jmp     start
;
CHCSMark db      13,10,9,'CHCS'
;
noCHCS  db      7, 'unwlib: CHCS/CHIS Chinese System not installed !'
        db      0dh,0ah, '$'
Usage   db      ' ÷: UNWLIB [/u]', 0dh,0ah
        db      '       ȱʡ: ʿ', 0dh,0ah
        db      '       /u  : Զʿ', 0dh,0ah
        db      '       (ͬһװ, һ𳷳)'
        db      0dh,0ah, '$'
noStd   db      7, 'unwlib: ʿδҽ', 0dh,0ah, '$'
noUsr   db      7, 'unwlib: Զʿδҽ', 0dh,0ah, '$'
;
start:  mov     ax, 3f00h
        int     16h
        mov     di, bx
        lea     si, CHCSMark
        mov     cx, 5
        cld
        repz    cmpsb
        jz      Cont0
        lea     dx, noCHCS
PrErr:  mov     ah, 09h
        int     21h
        mov     ax, 4cffh
        int     21h
;
Cont0:  mov     bx, 0081h
CmdLoop:mov     al, [bx]
        inc     bx
        cmp     al, ' '
        je      CmdLoop
        cmp     al, 09h
        je      CmdLoop
        cmp     al, 0dh
        je      UnStdWLib
        cmp     al, '/'
        je      Cont1
PrUse:  lea     dx, Usage
        jmp     PrErr
;
UnStdWLib:
        mov     ax, 3e00h
        int     16h
        or      ax, ax
        jz      isOk
        lea     dx, noStd
        jmp     PrErr
;
Cont1:  mov     al, [bx]
        or      al, 20h
        cmp     al, 'u'
        jne     PrUse
        mov     ax, 3e01h
        int     16h
        or      ax, ax
        jz      isOk
        lea     dx, noUsr
        jmp     PrErr
;
isOk:   mov     ax, 4c00h
        int     21h
code    ends
        end     begin
        
